<?php
#**************************************************************************
#  openSIS is a free student information system for public and non-public 
#  schools from Open Solutions for Education, Inc. web: www.os4ed.com
#
#  openSIS is  web-based, open source, and comes packed with features that 
#  include student demographic info, scheduling, grade book, attendance, 
#  report cards, eligibility, transcripts, parent portal, 
#  student portal and more.   
#
#  Visit the openSIS web site at http://www.opensis.com to learn more.
#  If you have question regarding this system or the license, please send 
#  an email to info@os4ed.com.
#
#  This program is released under the terms of the GNU General Public License as  
#  published by the Free Software Foundation, version 2 of the License. 
#  See license.txt.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#***************************************************************************************
// INSERT/UPDATE,[fields][values]/WHERE,[]fields/,Propernames
function SaveData($iu_extra,$fields_done=false,$field_names=false)
{
	if(!$fields_done)
		$fields_done = array();
	if(!$field_names)
		$field_names = array();

	if($_REQUEST['month_values'])
	{
		foreach($_REQUEST['month_values'] as $table=>$values)
		{
			foreach($values as $id=>$columns)
			{
				foreach($columns as $column=>$value)
				{
					$_REQUEST['values'][$table][$id][$column] = $_REQUEST['day_values'][$table][$id][$column].'-'.$value.'-'.$_REQUEST['year_values'][$table][$id][$column];
					if($_REQUEST['values'][$table][$id][$column]=='--')
						$_REQUEST['values'][$table][$id][$column] = '';
				}
			}
		}
	}
	foreach($_REQUEST['values'] as $table=>$values)
	{
		$table_properties = db_properties($table);
		foreach($values as $id=>$columns)
		{
			foreach($columns as $column=>$value)
			{
				if($field_names[$table][$column])
					$name = 'The value for '.$field_names[$table][$column];
				else
					$name = 'The value for '.ucwords(strtolower(str_replace('_',' ',$column)));

				// COLUMN DOESN'T EXIST
				if(!$table_properties[$column])
				{
					$error[] = 'There is no column for '.$name.'. This value was not saved.';
					continue;
				}

				// VALUE IS TOO LONG
				if($table_properties[$column]['TYPE']=='VARCHAR' && strlen($value) > $table_properties[$column]['SIZE'])
				{
					$value = substr($value,0,$table_properties[$column]['SIZE']);
					$error[] = $name . ' was too long.  It was truncated to fit in the field.';
				}

				// FIELD IS NUMERIC, VALUE CONTAINS NON-NUMERICAL CHARACTERS
				if($table_properties[$column]['TYPE']=='NUMERIC' && ereg('[^0-9-]',$value))
				{
					$value = ereg_replace('[^0-9]','',$value);
					$error[] = $name . ', a numerical field, contained non-numerical characters.  These characaters were removed.';
				}

				// FIELD IS DATE, DATE IS WRONG
				if($table_properties[$column]['TYPE']=='DATE' && $value && !VerifyDate($value))
				{
					$error[] = $name . ', a date field, was not a valid date.  This value could not be saved.';
					continue;
				}
				if($table_properties[$column]['TYPE']=='DATE' && $value)
				{
					$value = date('Y-m-d',strtotime($value));
				}
				if($id=='new')
				{
					if($value)
					{
						$ins_fields[$table] .= $column.',';
						$ins_values[$table] .= "'".str_replace("\'","''",$value)."',";
						$go = true;
					}
				}
				else
					if(strlen($value)>0)
						$sql[$table] .= "$column='".str_replace("\'","''",str_replace('&#39;',"''",$value))."',";
					else
						$sql[$table] .= "$column=NULL,";
			}
			if($id=='new')
				$sql[$table] = 'INSERT INTO '.$table.' (' . $iu_extra['fields'][$table].substr($ins_fields[$table],0,-1) . ') values(' . $iu_extra['values'][$table].substr($ins_values[$table],0,-1) . ')';
			else
				$sql[$table] = 'UPDATE '.$table.' SET '.substr($sql[$table],0,-1).' WHERE '.str_replace('__ID__',$id,$iu_extra[$table]);
			echo ErrorMessage($error);
			if($id!='new' || $go==true)
					DBQuery($sql[$table]);
			$error = $ins_fields = $ins_values = $sql = $go = '';
		}
	}
}
?>
