INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('1000', 1,
'Violation of laws or ordinances prohibiting the manufacture, sale, purchase, transportation, possession, or consumption of intoxicating alcoholic beverages or substances represented as alcohol. Suspicion of being under the influence of alcohol may be included if it results in disciplinary action.', 
'Alcohol');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('1010', 2,
'Selling alcoholic beverages.', 
'Sale of alcohol');


INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('1020', 3,
'Distributing (i.e., giving away) alcoholic beverages.', 
'Distribution of alcohol');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('1030', 4,
'Drinking alcoholic beverages.', 
'Drinking alcohol');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('1040', 5,
'Having alcoholic beverages in one''s pocket(s), bag(s), car, locker, etc.', 
'Possession of alcohol');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('1050', 6,
'Exhibiting behaviors that suggests that an individual consumed alcohol.', 
'Suspicion of alcohol use');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('1097', 7,
'The incident cannot be coded in one of the above categories but did involve an alcohol violation.', 
'Other alcohol');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('1100', 8,
'To unlawfully and intentionally damage, or attempt to damage, any school or personal property by fire or incendiary device. Firecrackers, fireworks, and trashcan fires would be included in this category if they were contributing factors to a damaging fire.', 
'Arson (Setting a Fire)');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('1200', 9,
'Violation of state, school district, or school policy relating to attendance.', 
'Attendance Policy Violation (Not Attending School or Classes as Required)');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('1300', 10,
'Touching or striking of another person against his or her will or intentionally causing bodily harm to an individual.', 
'Battery (Physical Attack/Harm)');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('1400', 11,
'Unlawful entry or attempted entry into a building or other structure with the intent to commit a crime.', 
'Burglary/Breaking and Entering (Stealing Property/Unlawful Entry)');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('1500', 12,
'Any act that disrupts the orderly conduct of a school function; behavior which substantially disrupts the orderly learning environment.', 
'Disorderly Conduct (Disruptive Behavior)');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('1600', 13,
'Unlawful use, cultivation, manufacture, distribution, sale, solicitation, purchase, possession, transportation, or importation of any controlled drug (e.g., demerol, morphine) or narcotic substance.', 
'Drugs Excluding Alcohol and Tobacco (Illegal Drug Possession, Sale, Use/Under the Influence)');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('1700', 14,
'Mutual participation in an incident involving physical violence, where there is no major injury.', 
'Fighting (Mutual Altercation)');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('1800', 15,
'Repeatedly annoying or attacking a student or group of students or other personnel which creates an intimidating or hostile educational or work environment.', 
'Harassment, Nonsexual (Physical, Verbal, or Psychological)');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('1900', 16,
'Unwelcome sexual advances, requests for sexual favors, other physical or verbal conduct or communication of a sexual nature, including gender-based harassment that creates an intimidating, hostile, or offensive educational or work environment.', 
'Harassment, Sexual (Unwelcome Sexual Conduct)');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('2000', 17,
'Killing a human being.', 
'Homicide (Murder or Manslaughter)');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('2100', 18,
'Use, possession, or distribution of any prescription or over-the-counter medication (e.g., aspirin, cough syrups, caffeine pills, nasal sprays) in violation of school policy.', 
'Inappropriate Use of Medication (Prescription or over-the-counter)');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('2200', 19,
'Unwillingness to submit to authority, refusal to respond to a reasonable request, or other situations in which a student is disobedient.', 
'Insubordination (Disobedience)');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('2300', 20,
'Unlawful seizure, transportation, and/or detention of a person against his/her will, or of a minor without the consent of his/her custodial parent(s) or legal guardian. This category includes hostage-taking.', 
'Kidnapping (Abduction)');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('2400', 21,
'Language or actions, written, oral, physical, or electronic, in violation of community or school standards.', 
'Obscene Behavior');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('2500', 22,
'Confrontation, tussle, or physical aggression that does not result in injury.', 
'Physical Altercation, Minor (Pushing, Shoving)');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('2600', 23,
'The taking of, or attempting to take, anything of value that is owned by another person or organization under confrontational circumstances by force or threat of force or violence and/or by putting the victim in fear. A key difference between robbery and theft is that the threat of physical harm or actual physical harm is involved in a robbery.', 
'Robbery(Taking of Things by Force)');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('2700', 24,
'Any threat (verbal, written, or electronic) by a person to bomb or use other substances or devices for the purpose of exploding, burning, causing damage to a school building or school property, or to harm students or staff.', 
'School Threat (Threat of Destruction or Harm)');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('2800', 25,
'Oral, anal, or vaginal penetration forcibly or against the person''s will or where the victim is incapable of giving consent. Includes rape, fondling, indecent liberties, child molestation, and sodomy.', 
'Sexual Battery (Sexual assault)');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('2900', 26,
'Sexual intercourse, sexual contact, or other behavior intended to result in sexual gratification without force or threat of force. Code statutory rape here', 
'Sexual Offenses, Other (Lewd Behavior, Indecent Exposure)');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('3000', 27,
'Act or instance of taking one''s own life voluntarily and intentionally.', 
'Suicide');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('3100', 28,
'The unlawful taking of property belonging to another person without threat, violence or bodily harm. Electronic theft of data should be coded here. Do not include dealing in stolen goods in this category', 
'Theft (Stealing Personal or School Property)');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('3200', 29,
'Physical, verbal, written, or electronic action which immediately creates fear of harm, without displaying a weapon and without subjecting the victim to actual physical attack.', 
'Threat/Intimidation (Causing Fear of Harm)');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('3300', 30,
'Possession, use, distribution, or sale of tobacco products.', 
'Tobacco (Possession or Use)');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('3400', 31,
'To enter or remain on a public school campus or school board facility without authorization or invitation and with no lawful purpose for entry.', 
'Trespassing (Unlawful or Unauthorized Presence)');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('3500', 32,
'Willful destruction or defacement of school or personal property.', 
'Vandalism (Damage to School or Personal Property)');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('3600', 33,
'This category comprises misbehavior not captured elsewhere. Problem behaviors could include dress code violations, running in the halls, possession of contraband, cheating, lying to authorities, or falsifying records.', 
'Violation of School Rules (Disobeying School Policy)');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('3700', 34,
'Possession of an instrument or object to inflict harm on other persons. Both firearms and other weapons should be coded here.', 
'Weapons Possession (Firearms and Other Weapons)');

INSERT INTO DISCIPLINE_INCIDENT_LKUP
( incident_code,
  incident_id,
  incident_description,
  incident_display
)
values
('9000', 35,
'Any significant incident resulting in disciplinary action not classified previously. Offenses could include bribery, fraud, embezzlement, forgery, resisting arrest, gambling, extortion, or dealing in stolen property.', 
'Other Offenses (e.g., Forgery, Extortion)');