<?php
#**************************************************************************
#  openSIS is a free student information system for public and non-public 
#  schools from Open Solutions for Education, Inc. web: www.os4ed.com
#
#  openSIS is  web-based, open source, and comes packed with features that 
#  include student demographic info, scheduling, grade book, attendance, 
#  report cards, eligibility, transcripts, parent portal, 
#  student portal and more.   
#
#  Visit the openSIS web site at http://www.opensis.com to learn more.
#  If you have question regarding this system or the license, please send 
#  an email to info@os4ed.com.
#
#  This program is released under the terms of the GNU General Public License as  
#  published by the Free Software Foundation, version 2 of the License. 
#  See license.txt.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#***************************************************************************************
include 'Warehouse.php';
// DEFAULT
if(User('PROFILE')=='admin')
	$help['default'] = '<p><strong>openSIS Dashboard</strong></p><p>The Dashboard is your default home page and provides access to important alerts when you log in to the application. The openSIS dashboard shows all recent calendar event information, portal notes and alerts for teachers that have missing attendance. When you login for the first time it will be a blank screen. It will fill up as and when you add day-today records in your instance of the software. As an administrator, you can setup the schools in this system, modify students and users, and access essential student reports.</p><p>You have access to any school in the system.  To choose a school to work on, select the school from the pull-down menu on the top.  The program will automatically refresh with the new school in the workspace. You can also change the school year and current marking period in a similar fashion.</p><p>You can also quickly access a Student\'s Demographic Information from the Student\'s tab.</p><p>Similarly to access a User\'s Information click on the User tab.</p><p>When you click on any of the tabs in the top menu, you will see a list of sub-menus available to you in that category.  Clicking on any menu will launch the specific page in the main frame, and it will update the help frame to display help for that section.</p><p>In many places in openSIS, you will see data that are modifiable.  You will have to first click the value you want to change to have access to an input field.  Then, when you change the value and save, the value will return to its previous state.</p><p>You can logout of openSIS at any time by clicking the "Logout" link at the top right of your workspace.</p>';
elseif(User('PROFILE')=='teacher')
	$help['default'] = '<p> The Dashboard is your default home page and provides access to important alerts when you log in to the application. The openSIS dashboard shows all recent calendar event information, portal notes and alerts for teachers that have missing attendance. When you login for the first time it will be a blank screen. It will fill up as and when you add day-today records in your instance of the software. As a teacher, you can view student information and schedules for students who you teach and input attendance, grades, and eligibility for these students. You can keep track of students\' grades from the Grades tab.  From this tab, not only can you keep track of grades, but you can print progress reports for any of your students.</p><p>To choose a period to work on, select the period from the pull-down menu on the top.  The program will automatically refresh with the new period in the workspace. You can also change the school year and current marking period in a similar fashion.</p><p> You can also quickly access a Student\'s Demographic Information from the Student\'s tab.</p><p> When you click on any of the tabs in the top menu, you will see a list of sub-menus available to you in that category.  Clicking on any menu will launch the specific page in the main frame, and it will update the help frame to display help for that section.</p><p>In many places in openSIS, you will see data that are modifiable.  You will have to first click the value you want to change to have access to an input field.  Then, when you change the value and save, the value will return to its previous state.</p><p>You can logout of openSIS at any time by clicking the "Logout" link at the top right of your workspace.</p>';
elseif(User('PROFILE')=='parent')
	$help['default'] = '<p> The Dashboard is your default home page and provides access to important alerts when you log in to the application. The openSIS dashboard shows all recent calendar event information, portal notes and alerts for teachers that have missing attendance. When you login for the first time it will be a blank screen. It will fill up as and when you add day-today records in your instance of the software. As a parent, you can view your children\'s information, schedules, grades, eligibility, and attendance.</p><p>To choose a child, select the child\'s name from the pull-down menu on the top.  The program will automatically refresh with the new child in the workspace. You can also change the school year and current marking period in a similar fashion.</p><p> When you click on any of the tabs in the top menu, you will see a list of sub-menus available to you in that category.  Clicking on any menu will launch the specific page in the main frame, and it will update the help frame to display help for that section.</p><p>In many places in openSIS, you will see data that are modifiable.  You will have to first click the value you want to change to have access to an input field.  Then, when you change the value and save, the value will return to its previous state.</p><p>You can logout of openSIS at any time by clicking the "Logout" link at the top right of your workspace.</p>';
elseif(User('PROFILE')=='student')
{
	$help['default'] = '<p>The Dashboard is your default home page and provides access to important alerts when you log in to the application. The openSIS dashboard shows all recent calendar event information and portal notes. When you login for the first time it will be a blank screen. It will fill up as and when new portal notes and events are added in your instance of the software. As a student, you can view your demographic information, schedule, grades, eligibility, and attendance records.</p><p>You can change the school year and current marking period with the pull-down menus in the left frame to view records for that specific period.</p><p> When you click on any of the tabs in the top menu, you will see a list of sub-menus available to you in that category.  Clicking on any menu will launch the specific page in the main frame, and it will update the help frame to display help for that page.</p><p>You can logout of openSIS at any time by clicking the "Logout" link at the top right of your workspace.</p>';
	$_CENTRE['User'][1]['PROFILE'] = 'parent';
	$student = true;
}

// SCHOOL SETUP ---
if(User('PROFILE')=='admin')
{
	$help['School_Setup/PortalNotes.php'] = '<p><strong>Portal Notes</strong></p><p>This page allows you to add Notes to the system. Notes help to keep users of the system informed about any new developments in the School. You can choose the time period for which the specific note will be visible to users. You can also specify which users can view the same. <p>To modify a note, click on any of the note\'s information, change the value, and click the "Save" button.</p><p>To delete an note, click the delete icon (-) next to the note you want to delete.  You will be asked to confirm the deletion.</p>';
	$help['School_Setup/Schools.php'] = '<p><strong>School Information</strong></p><p>The automated installer creates a default school during installation. Once logged in, you can update the existing information with your School�s Information viz. change the name, address, and principal of the current school from this page.</p><p>To edit and change the default school information, simply click on the existing text and it will become an editable text input field. Enter the updated information and click �Update.�You also have the option to delete the school. However you cannot delete a school if you have existing students enrolled in that school.</p>';
	$help['School_Setup/Schools.php?new_school=true'] = '<p><strong>Add a School</strong></p><p>This page allows you to add a school to the system.  Complete the school\'s information, and hit the "Save" button.</p><p>To switch to the new school you just added, change the school pull-down menu on the top from your current school to the new one.</p>';
	$help['School_Setup/CopySchool.php'] = '<p><strong>Copy School</strong></p><p>This page lets you make a copy of your existing school. The data copied includes School Periods, Marking Periods, Report Card Grade Codes, Report Card Comment Codes, Eligibility Activity Codes, Attendance Codes and Grade Levels.</p>';
	$help['School_Setup/MarkingPeriods.php'] = '<p><strong>Marking Periods</strong></p><p>The Marking Periods page is where you setup your school\'s marking periods for a school year. There are four default tiers of marking periods added during the installation: Year, Semesters, Quarters, and Progress periods. openSIS installation scripts create 2 Semesters and 4 Quarters by default. However you can always have more or fewer as required by your school. Similarly, there can be any number of progress periods in a given quarter. </p><p>To add a marking period, click on the Add button (+) in the column corresponding to the type of marking period you want to add. Then, complete the marking period\'s information in the fields above the list of marking periods and click the "Save" button. </p><p>To edit a marking period, click on the marking period you want to change, and click on whatever value you want to change. It will automatically become editable. Update the value and click the "Save" button. </p><p>To delete a marking period, select it by clicking on its title on the list and click the "Delete" button at the top of the screen. You will be asked to confirm the deletion. </p><p>Note: You cannot delete a marking period if it has students assigned to periods in that marking period. </p><p>Notice that neither two marking periods nor two posting periods in the same tier can overlap dates.</p>';
	$help['School_Setup/Calendar.php'] = '<p><strong>School Calendar</strong></p><p>This page allows you to setup your school\'s calendar for the year.  The calendar displays the current month by default. The month and year displayed can be changed by changing the month and year pull-down menus at the top of the screen and clicking the "Update" button.</p><p>On full school days, the checkbox in the upper right-hand corner of the day\'s square should be checked.  For partial days, the checkbox should be unchecked and the number of minutes school will be in attendance should be entered into the text box next to the checkbox.  For days on which there will be no school, the checkbox should be unchecked and the text field should be blank. To uncheck the checkbox or change the number of minutes in the school day, you must first click on the value you want to change. After making any changes to the calendar, click the "Update" button at the top of the screen.</p><p>To setup your calendar at the beginning of the year, you should use the "Create this year\'s calendar" feature.  By clicking on this link in the upper right-hand corner of the screen, you can setup all days in a specified timeframe as meeting all day.  You can also select which days of the week that your school is in session.  After selecting the beginning and ending dates of your school\'s school year and the day\'s of the week that your school meets, click the "OK" button. You can now go through the calendar and mark holidays and partial days.</p><p>The calendar is also a display of school events. This can include everything from teacher in-service days to sporting events.  These events are visible by other administrators as well as parents and teachers at your school.</p><p>To add a school event, click on the add icon (+) in the lower left-hand corner of the event\'s date.  In the popup window that appears, enter the event\'s information and click the "Save" button.  The popup window will close, and the calendar will be automatically refreshed to display the added event.</p><p>To modify an event, click on the event you want to modify, and change the event\'s information in the popup window that appears after clicking on the values you want to change.  Click the "Save" button.  The window will close and the calendar will automatically refresh to display the change.</p>';
	$help['School_Setup/Periods.php'] = '<p><strong>School Periods</strong></p><p>This page allows you to setup your school\'s individual class periods. The openSIS installation script creates a group of default periods. Update these periods to match yours and delete the extra periods created during installation if necessary. </p><p>Middle and high schools will likely have multiple periods in a school day, where elementary schools may have only one period (called All Day) or perhaps three (All Day, Morning, and Afternoon). If required, you can add new periods very easily. To add a period, fill in the period\'s title, short name, sort order, and length in minutes in the empty fields at the bottom of the periods list and click the "Save" button. </p><p>To modify a period, click on any of the period\'s information, change the value, and click the "Save" button. To delete a period, click the delete icon (X) next to the period you want to delete. You will be asked to confirm the deletion.</p>';
	$help['School_Setup/GradeLevels.php'] = '<p><strong>School Grade Levels</strong></p><p> This page allows you to setup your school\'s grade levels. By default the openSIS installer creates all the grades from Kindergarten to the 8th Grade. If your school has a different grade level structure, simply delete the extra Grade Levels. Similarly if you have some grades that have not been created, create them on this page. </p><p>To add a grade level, fill in the grade level\'s title, short name, sort order, and next grade in the empty fields at the bottom of the grade levels list and click the "Save" button. The "Next Grade" field indicates the grade students in the current grade will proceed to in the next school year. </p><p>To modify a grade level, click on any of the grade level\'s information, change the value, and click the "Save" button. To delete a grade level, click the delete icon (X) next to the grade level you want to delete. You will be asked to confirm the deletion.</p>';
	$help['School_Setup/Rollover.php'] = '<p><strong>Rollover School</strong></p><p>The Rollover page copies the current year\'s data to the next school year.  Students are enrolled in the next grade, and each school\'s information is duplicated for the next school year.</p><p>The data copied include periods, marking periods, users, courses, student enrollment, report card grade codes, enrollment codes, attendance codes, and eligibility activities.</p>';

}

else
{
	$help['School_Setup/Schools.php'] = '<p><strong>School Information</strong></p><p> displays the name, address, and principal of the current school.</p>';
	$help['School_Setup/Calendar.php'] = '<p><strong>School Calendar</strong></p><p>The Calendar is a display of school events and your student\'s assignments.  The calendar also displays whether or not school is in attendance on any given day.  By default, the calendar displays the current month.  The month and year displayed can be changed by changing the month and year pull-down menus at the top of the screen and clicking the "Update" button.</p><p>The titles of school events and assignments are displayed in each date\'s box.  Clicking on these titles will open a popup window that displays more information about the event or assignment. School assignments are preceded by a red dot and assignments are preceded by a blue dot.</p><p>For days that school is in attendance all day, a green checkmark appears in the upper right-hand corner of the date.  On partial days, the number of minutes that school is in session is displayed here instead. If the school is not in attendance at all on any given day, nothing will appear in the upper right-hand corner of the date.</p>';
    $help['School_Setup/MarkingPeriods.php'] = '<p><strong>Marking Periods</strong></p><p>The Marking Periods page is where you setup your school\'s marking periods for a school year. There are four default tiers of marking periods added during the installation: Year, Semesters, Quarters, and Progress periods. openSIS installation scripts create 2 Semesters and 4 Quarters by default. However you can always have more or fewer as required by your school. Similarly, there can be any number of progress periods in a given quarter. </p><p>To add a marking period, click on the Add button (+) in the column corresponding to the type of marking period you want to add. Then, complete the marking period\'s information in the fields above the list of marking periods and click the "Save" button. </p><p>To edit a marking period, click on the marking period you want to change, and click on whatever value you want to change. It will automatically become editable. Update the value and click the "Save" button. </p><p>To delete a marking period, select it by clicking on its title on the list and click the "Delete" button at the top of the screen. You will be asked to confirm the deletion. </p><p>Note: You cannot delete a marking period if it has students assigned to periods in that marking period. </p><p>Notice that neither two marking periods nor two posting periods in the same tier can overlap dates.</p>';
}

// STUDENTS ---
if(User('PROFILE')=='admin')
{
	$help['Students/Student.php?include=General_Info?student_id=new'] = "<p>The \"Add a Student\" page allows you to add a student to the system.</p><p>To add the student, enter the birth date, social security number, ethnicity, gender, birthplace, and grade.  Then, select the effective date of the student's enrollment and the enrollment code from the pull-down menus at the bottom of the page. If you wish to specify a student ID for this student, enter the student ID into the text field labeled student ID.  if you leave this field blank, openSIS will generate an unused student ID and assign it to the new student.  Finally, click the \"Save\" button at the top of the screen.</p>";
	$help['Students/Letters.php'] = "<p>The \"Print Letters\" page allows you to print form letters for any number of students.</p><p>To print the letters, enter the letter text in the \"Letter Text\" text field at the bottom of the search screen.  Then search for students by filling in any desired search field, and click the \"Submit\" button.</p><p>You can insert certain pieces of student information into your letter with special variables:<UL><LI><b>Full Name:</b> __FULL_NAME__</LI><LI><b>First Name:</b> __FIRST_NAME__</LI><LI><b>Middle Name:</b> __MIDDLE_NAME__</LI><LI><b>Last Name:</b> __LAST_NAME__</LI><LI><b>Student ID:</b> __STUDENT_ID__</LI><LI><b>Grade:</b> __GRADE_ID__</LI></UL></p><p>Also, you can choose to print the letters with mailing labels.  The letters will have mailing labels positioned in such a way as to be visible in a windowed envelope when the sheet is folded in thirds.  More than one letter may be printed per student if the student has guardians residing at more than one address.</p><p>The letters will be automatically give you a printer-friendly html format when you click the \"Submit\" button.</p>";
	$help['Students/Student.php?include=General_Info'] = "<p>The \"General Information\" tab is a display of a student's fundamental information. This includes birth date, social security number, ethnicity, gender, birthplace, and grade.  You can change any of this information by clicking on the value you want to change, changing the value, and clicking the \"Save\" button at the top of the page.</p>";
	$help['Students/Student.php?include=Address'] = "<p>The \"Address\" tab displays a student\'s address and contact information.</p><p>A student must have one addresses and two mandatory emergency contacts. To add an address, complete the empty fields at the bottom of the Address screen, and click the \"Save\" button at the top of the screen.</p><p>Now, you can add a contact to this address.  To do this, complete the contact's name, and again, press the \"Save\" button.</p><p>You can now add more information about this contact by checking the \"Custody\" and \"Emergency\" checkboxes, after first clicking on their default value of \"No.\" Relations marked as having \"Custody\" of the student receive mailings and relations marked as being \"Emergency\" contacts can be contacted in the case of an emergency.</p><p>You can add other information about this contact, such as their cell phone number, fax number, occupation, workplace, etc. by filling in the title of the new data in the empty field with the default value  and its corresponding value in the empty field to the right.</p><p>Contacts and information about contacts can be deleted by clicking on the delete icon (-) next to the information to be deleted. (Note: you will be asked to confirm all deletions.) Any information on the screen can be modified by first clicking on the information, then changing its value, and finally clicking the \"Save\" button at the top of the screen.</p>";
	$help['Students/Student.php?include=Medical'] = "<p>The \"Medical\" tab displays a  student\'s medical information.</p><p>This includes the student\'s physician, the physician\'s phone, the student\'s preferred hospital, any medical comments, whether or not the student has a doctor's note, and comments concerning the doctor's note.  To change any of these values, click on the value you want to change, change it, and click the \"Save\" button at the top of the screen.</p><p>You can also add entries for each immunization or physical received by the student as well as any medical alerts such as allergies or illnesses.</p><p>To add an immunization, physical, or medical alert, fill in the blank fields at the bottom of the appropriate list, and click the \"Save\" button at the top of the screen.</p><p>To change an immunization, physical, or medical alert, click on the value you want to change, change it, and click the \"Save\" button at the top of the screen.</p><p>To delete an immunization, physical, or medical alert, click on the delete icon (-) next to the item you want to delete.  You will be asked to confirm your deletion.</p>";
	$help['Students/Student.php?include=Enrollment'] = '<p>The \"Enrollment\" page can be used to enroll or drop a student from any school. A student can have only one active enrollment record at any time.</p><p>To drop a student, change the "Dropped" date and reason to the effective date of the student\'s drop as well as the reason for his drop. Click the "Save" button at the top of the screen.</p><p>Now you can re-enroll the student.  To do this, select the effective date of the student\'s enrollment and the reason for his enrollment from the blank line at the bottom of the list.  Also, select the school at which the student should be enrolled and click the "Save" button at the top of the screen.</p><p>The enrollment and drop dates and reasons can be modified by clicking on the values, changing them to the desired value, and clicking the "Save" button at the top of the screen.</p>';
	$help['Students/DataFields.php'] = '<p>The \"Data Fields\" page allows you to setup your school\'s custom data fields.  These fields are used to store information about a student in the "Other Info" student screen.</p><p>There are four types of Data Fields, text fields, checkbox fields, date fields, and pull-down menu fields. Text fields can store any text value up to 255 characters long.  Checkbox fields can be checked, indicating "Yes" or remain unchecked, indicating "No." Date fields store dates, and pull-down menu fields allow you to select any one of a set of predetermined values.</p><p>To add a data field, fill in the data field\'s title and data type, and select whether or not the field should appear on student search screens in the empty fields at the bottom of the data fields list. If the field is a pull-down menu, enter each of the available options in the "Pull-down Options" field separated by commas. Otherwise, leave this field blank.  Click the "Save" button.</p><p>To modify a data field, click on any of the data field\'s information, change the value, and click the "Save" button.</p><p>To delete a data field, click the delete icon (-) next to the data field you want to delete.  You will be asked to confirm the deletion.</p>';
	$help['Students/EnrollmentCodes.php'] = '<p>The \"Enrollment Codes\" page allows you to setup your school\'s enrollment codes.  Enrollment codes are used in the Enrollment student screen, and specify the reason the student was enrolled or dropped from a school.  These codes apply to all schools system-wide.</p><p>To add an enrollment code, fill in the enrollment code\'s title, short name, and type in the empty fields at the bottom of the enrollment codes list. Click the "Save" button.</p><p>To modify an enrollment code, click on any of the enrollment code\'s information, change the value, and click the "Save" button.</p><p>To delete an enrollment code, click the delete icon (-) next to the enrollment code you want to delete.  You will be asked to confirm the deletion.</p>';

}

if(User('PROFILE')=='teacher')
{
   $help['Students/Student.php?include=General_Info'] = "<p></strong>General Information</strong></p><p> is a display of a student's fundamental information. This includes birth date, social security number, ethnicity, gender, birthplace, and grade.</p>";
}
else
{
	$help['Students/Student.php?include=General_Info'] = "<p></strong>General Information</strong></p><p> is a display of a student's fundamental information. This includes birth date, social security number, ethnicity, gender, birthplace, and grade.</p>";
	$help['Students/Student.php?include=Address'] = "<p></strong>Address &amp; Contacts</strong></p><p> is a display of a student's address and contact information.</p><p> A student must have one addresses and two mandatory emergency contacts.</p>";
	$help['Students/Student.php?include=Enrollment'] = '<p></strong>Enrollment</strong></p><p> is a display of the student\'s enrollment history.</p>';

}

// USERS
if(User('PROFILE')=='admin')
{
	$help['Users/User.php'] = "<p><strong>User Information</strong></p><p>This page displays a user's fundamental information. This includes his name, username, password, profile, school, email address, and phone number.  You can change any of this information by clicking on the value you want to change, changing the value, and clicking the \"Save\" button at the bottom of the page. </p>";
	$help['Users/User.php?staff_id=new'] = "<p><strong>Add a User</strong></p><p>This page allows you to add a user to the system. This includes administrators, teachers, and parents. Simply fill in the new user's name, username, password, profile, school, email address, and phone number. Click the \"Save\" button.</p><p><strong>Note:</strong> No two users can have identical usernames.</p>";
	$help['Users/AddStudents.php'] = "<p><strong>Associate Students with Parents</strong></p><p>This page allows you to associate students to parents.</p><p>Once a parent's account has been set up, their children must be associated to their account with this program.  If you have not already chosen a user earlier in your session, select a user by using the \"Find a User\" Search screen.  Next, search for a student to add to the user's account.  From the search result, you can select any number of students.  You can select all the students in the list by checking the checkbox in the blue column headings above the list. After you have selected each desired student from this list, click the \"Add Selected Students\" button at the top of the screen.</p><p>At any time after a user has been selected, you can see the students already associated with that user.  These students are listed to the left of the student search screen / search results.  These students can be disassociated from this user by clicking the delete icon (-) next to the student you wish to disassociate from the user.  You will be asked to confirm this action.</p>";
	$help['Users/Preferences.php'] = "<p><strong>Preferences</strong></p><p>This page allows you to deny access and/or write privileges to any program for any admin user.</p><p>To assign privileges to an admin user, first select an administrator by searching for one and clicking on his name on the list.  Then, use the checkboxes to define which programs the administrator can use and which programs he can use to modify information.  If a user cannot use a particular program, the program will not be displayed on his menu.  If he can use the program, but can't edit information with the program, the program will display the data, but won't let him change it.  After you have completed the program checkboxes, click the \"Save\" button to save the administrator's permissions.</p>";
	$help['Users/TeacherPrograms.php?include=Grades/InputFinalGrades.php'] = "<p><strong>Teacher Programs &raquo; Input Final Grades</strong></p><p>This page allows you to enter quarter, semester, and semester exam grades for all the selected teacher's students in the current period. By default, this program will list the students in the selected teacher's first period class for the current quarter.  You can alter the period by changing the period pull-down menu at the top of the screen.  Also, you can alter the quarter by changing the marking period pull-down menu on top.  Furthermore, you can select the current semester or semester final by changing the marking period pull-down menu at the top of the screen to the desired marking period.</p><p>Once you are in the correct marking period, you can enter student grades by selecting the earned grade for each student and entering comments as desired.  Once all the grades and comments have been entered, click the \"Save\" button at the top of the screen.</p><p>If the selected teacher is using the Grades, you can have openSIS calculate each student's quarter grades by clicking on the \"Use Gradebook Grades\" link at the top of the list.  Clicking this link will automatically save each student's grades and refresh the list.</p>";
	$help['Users/TeacherPrograms.php?include=Grades/Grades.php'] = "<p><strong>Teacher Programs &raquo; GradeBook Grades</strong></p><p></p>";
	$help['Users/TeacherPrograms.php?include=Attendance/TakeAttendance.php'] = "<p><strong>Teacher Programs &raquo; Take Attendance</strong></p><p>This page allows you to enter period attendance for all the selected teacher's students.  By default, this program will list the students in the selected teacher's first period class.  You can alter the current period by changing the period pull-down menu at the top of the screen to the desired period.</p><p>Once you are in the correct period, you can enter attendance by selecting the attendance code corresponding to each student.  Once you have entered attendance for all the students, click the \"Save\" button at the top of the screen.</p>";
	$help['Users/TeacherPrograms.php?include=Eligibility/EnterEligibility.php'] = "<p><strong>Teacher Programs &raquo; Enter Eligibility</strong></p><p>This page allows you to enter eligibility grades for all the selected teacher's students.  By default, this program will list the students in the selected teacher's first period class.  You can alter the current period by changing the period pull-down menu in the left frame to the desired period.</p><p>Once you are in the correct period, you can enter eligibility grades by selecting the eligibility code corresponding to each student.  Once you have entered eligibility for all the students, click the \"Save\" button at the top of the screen.</p><p>You must enter eligibility each week during the timeframe specified by your school's administration.</p>";
	$help['Users/Profiles.php'] = "<p><strong>User Profiles</strong></p><p>You can administer the sections of the application a user can access and edit.</p>";
	$help['Users/Exceptions.php'] = "<p><strong>User Permissions</strong></p><p>This page allows you to view the access right for a user.</p>";
	$help['Users/UserFields.php'] = "<p><strong>User Fields</strong></p><p>This page allows you to create custom fields for demographic information on a user.</p><p>Click on the (+) buton to create a new User Field. You can also choose to assign view rights to user roles for that field.</p>";

}

if(User('PROFILE')=='teacher')
{
    $help['Users/User.php'] = "<p><strong>User Information</strong></p><p>This page displays a user's fundamental information. This includes his name, username, password, profile, school, email address, and phone number.  You can change any of this information by clicking on the value you want to change, changing the value, and clicking the \"Save\" button at the bottom of the page. </p>";
}

// SCHEDULING
if(User('PROFILE')=='admin')
{
	$help['Scheduling/Schedule.php'] = "<p><strong>Student Schedule</strong></p><p> This page allows you to modify a student's course schedule. <p>You must first select a student by using the \"Find a Student\" search screen. You can search for students who have requested a specific course or request by clicking on the \"Choose\" link next to the search options \"Course\" and \"Request\" respectively and choosing a course from the popup window that appears.</p><p>To add a course to the student's schedule, click on the \"Add a Course\" link next to the add icon (+) and select a course from the popup window that appears. The screen will automatically refresh to show the course addition.</p><p>To drop an existing course, click on the delete icon (-) next to the course you want to drop from the student's schedule.</p><p>To change the course period of a course for the student, click on the \"Period - Teacher\" of the course you want to change and select the new course period.  You can also change the term in the same fashion.</p><p>All additions, deletions, and modifications to a student's schedule are not made permanent until you click the \"Save\" button at the top of the screen and confirm your modifications.  In addition, you will have to specify the effective date (the date on which your changes should take effect) on the confirmation screen.</p>";
	$help['Scheduling/Requests.php'] = "<p><strong>Student Requests</strong></p><p>The \"Student Requests</i>\" page allows you to specify which courses a student intends to take in the next school year.  These requests are used by the Scheduler when filling a student's schedule.</p><p>You can add a request by selecting the course you want to add from under the corresponding subject heading.  You can add requests from each subject in the same way, or you can add another request in the same subject by clicking on the add icon (+) next to the subject name.  Doing this will cause another set of request pull-down menus to appear under the subject heading.  Once you have added all the desired requests, click the \"Save\" button at the top of the screen.</p><p>When you save the student's requests, the Requests program will run the Scheduler without saving the schedule for the current student to notify you of any conflicts.  The Scheduler output will also tell you if any course requested has zero available seats. If a request could not be met, you can change the requests accordingly to ensure complete scheduling. You will also be given the option to schedule the student with the requests you entered.</p><p>Furthermore, when you have saved the student's requests, you will have the option to specify a teacher or period and to exclude a teacher or period.  To do this, select the teacher or period from the \"With\" and \"Without\" pull-down menus respectively.  You can also delete a request that you entered by changing the course and weight to \"Not Specified.\" Once you have made all the desired modifications, click the \"Save\" button again.</p>";
	$help['Scheduling/MassRequests.php'] = "<p><strong>Group Requests</strong></p><p>This utility allows you to add a request to a group of students in one action.</p><p>First, select a course to be added as a request by clicking the \"Choose a Course\" link at the top of the screen and choosing the course from the popup screen that appears. You can also perform this action from the next screen.  Next, search for students.  Notice that you can search for students who already have a certain request or are in a certain activity.  This can be useful since you can add a laboratory course request to all students who requested chemistry.  Or you can add a P.E. course request to all students in Boy's Basketball.  From the search result, you can select any number of students. To select all the students in the list, check the checkbox in the blue column headings above the list. After you have selected each desired student from this list, click the \"Add Course to Selected Students\" button at the top of the screen. If you have not yet chosen a course to add as a request, you must do that before you click this button.</p>";
	$help['Scheduling/MassSchedule.php'] = "<p><strong>Group Schedule</strong></p><p>This utility allows you to add a schedule to a group of students in one action.</p><p>First, select a course to be added as a request by clicking the \"Choose a Course\" link at the top of the screen and choosing the course from the popup screen that appears. Select the starting date for the course and the marking period in which you want to schedule the students. Select the students in the grid below and click the \"Save\" button. The selected schedule will be added to the selected students.</p>";
	$help['Scheduling/MassDrops.php'] = "<p><strong>Group Drops</strong></p><p>This utility allows you to add a remove a group of students from a schedule in one action.</p><p>First, select a course to be removed by clicking the \"Choose a Course\" link at the top of the screen and choosing the course from the popup screen that appears. Select the starting date for the course and the marking period in which you want to remove the students. Select the students in the grid below and click the \"Save\" button. The selected schedule will be removed from the selected schedule.</p>";
	$help['Scheduling/ScheduleReport.php'] = "<p><strong>Student Schedule Report</strong></p><p>This report shows the students who are scheduled into each course, the students who requested the course but weren't successfully scheduled into it, and the number of requests, open seats, and total seats in each course.</p><p>To navigate through this report, first click on any one of the subjects.  You will now see each course in that subject as well as the number of requests for that course and open and total seats available for that course.  If you choose a course by clicking on it, you will see a list of the course weights, and the requests, open, and total seats numbers will be broken down by each weight.  Here, you can also see a list of students scheduled in the course or a list of students who requested the course but weren't scheduled into it by clicking the \"List Students\" and \"List Unscheduled Students\" links respectively.</p><p>If you select a weight by clicking on it, the open / total seats will be broken down even farther by each period.  Here again you can list scheduled and unscheduled students.  Also, you can select a single course period and list the scheduled and unscheduled students.</p><p>At any point after selecting a subject, you can navigate backwards by clicking on the links that appear in the grey bar at the top of the screen.  These links also show you which students you are viewing.</p>";
	$help['Scheduling/RequestsReport.php'] = "<p><strong>Student Requests Report</strong></p><p>This report shows the number of students who requested each course and the number of total seats in that course. The courses are grouped by subject.</p><p>This report is useful for creating the master schedule since it helps you determine the number of course periods necessary for each course due to demand for the course.</p>";
	$help['Scheduling/PrintSchedules.php'] = "<p><strong>Student Schedules Report</strong></p><p>This report allows you to print schedules for any number of students.</p><p>You can search for students who requested or are enrolled in a specific course by clicking the \"Choose\" link next to the \"Request\" and \"Course\" search options respectively and choosing a course from the popup window that appears.</p><p>Also, you can choose to print the schedules with mailing labels.  The schedules will have mailing labels positioned in such a way as to be visible in a windowed envelope when the sheet is folded in thirds.  More than one schedule may be printed per student if the student has guardians residing at more than one address.</p><p>The schedules will be automatically downloaded to your computer in the printable PDF format when you click the \"Submit\" button.</p>";
	$help['Scheduling/PrintRequests.php'] = "<p><strong>Student Requests Report</strong></p><p>This report allows you to print requests sheets for any number of students.</p><p>You can search for students who requested a specific course by clicking the \"Choose\" link next to the \"Request\" search option and choosing a course from the popup window that appears.</p><p>Also, you can choose to print the requests sheets with mailing labels.  The requests sheets will have mailing labels positioned in such a way as to be visible in a windowed envelope when the sheet is folded in thirds.  More than one request sheet may be printed per student if the student has guardians residing at more than one address.</p><p>The request sheets will be automatically downloaded to your computer in the printable PDF format when you click the \"Submit\" button.</p>";
	$help['Scheduling/PrintClassLists.php'] = "<p><strong>Student Class List Report</strong></p><p>This report allows you to print requests sheets for any number of students.</p><p>You can search for students who requested a specific course by clicking the \"Choose\" link next to the \"Request\" search option and choosing a course from the popup window that appears.</p><p>Also, you can choose to print the requests sheets with mailing labels.  The requests sheets will have mailing labels positioned in such a way as to be visible in a windowed envelope when the sheet is folded in thirds.  More than one request sheet may be printed per student if the student has guardians residing at more than one address.</p><p>The request sheets will be automatically downloaded to your computer in the printable PDF format when you click the \"Submit\" button.</p>";
	$help['Scheduling/Courses.php'] = '<p><strong>Setup &raquo; Courses</strong></p><p>This utility allows you to setup your school\'s courses.  There are four tiers of courses: Subjects, Courses, Course Weights, and Course Periods.</p><p>To add any of these four things, click on the Add icon (+) in the column corresponding to what you want to add.  Then, fill in the information requested in the fields above the list of marking periods and click the "Save" button.</p><p>To change any of these four things, click on the item you want to change, and click on whatever value you want to change in the grey area above the lists.  Then, change the value and click the "Save" button.</p><p>Finally, to delete something, select it by clicking on its title on the list and click the "Delete" button at the top of the screen.  You will be asked to confirm the deletion.</p>';
	$help['Scheduling/Scheduler.php'] = "<p><strong>Setup &raquo; Run Scheduler</strong></p><p>This utility schedules every student at your school according to the requests entered for them.</p><p>You first must confirm the Scheduler run.</p><p>Once the scheduler has run, which could take several minutes, it will notify you of any conflicts.  The Scheduler output will also tell you if any course requested has zero available seats. If a request could not be met, you can change the requests accordingly to ensure complete scheduling. Once the schedules have been saved, you will be given the option to view the Schedule Report.</p><p>The \"Delete Current Schedule\" deletes all the currently assigned schedules.</p>";

}
elseif(User('PROFILE')=='parent')
{
	$help['Scheduling/Schedule.php'] = "<p><strong>Schedule</strong></p><p> is a display of your child's course schedule.</p>";
	$help['Scheduling/PrintRequests.php'] = "<p><strong>Print Requests</strong></p><p> is a utility that allows you to print requests sheets for your child.</p><p>The request sheets will be automatically downloaded to your computer in the printable PDF format when you click the \"Submit\" button.</p>";

}
else
	{
        $help['Scheduling/Schedule.php'] = "<p><strong>Schedule</strong></p><p> is a display of the student's course schedule. <p>You must first select a student by using the \"Find a Student\" search screen. You can search for students who have requested a specific course or request by clicking on the \"Choose\" link next to the search options \"Course\" and \"Request\" respectively and choosing a course from the popup window that appears.</p>";
        $help['Scheduling/PrintSchedules.php'] = "<p><strong>Student Schedules Report</strong></p><p>This report allows you to print schedules for any number of students.</p><p>You can search for students who requested or are enrolled in a specific course by clicking the \"Choose\" link next to the \"Request\" and \"Course\" search options respectively and choosing a course from the popup window that appears.</p><p>Also, you can choose to print the schedules with mailing labels.  The schedules will have mailing labels positioned in such a way as to be visible in a windowed envelope when the sheet is folded in thirds.  More than one schedule may be printed per student if the student has guardians residing at more than one address.</p><p>The schedules will be automatically downloaded to your computer in the printable PDF format when you click the \"Submit\" button.</p>";
        $help['Scheduling/PrintClassLists.php'] = "<p><strong>Student Class List Report</strong></p><p>This report allows you to print requests sheets for any number of students.</p><p>You can search for students who requested a specific course by clicking the \"Choose\" link next to the \"Request\" search option and choosing a course from the popup window that appears.</p><p>Also, you can choose to print the requests sheets with mailing labels.  The requests sheets will have mailing labels positioned in such a way as to be visible in a windowed envelope when the sheet is folded in thirds.  More than one request sheet may be printed per student if the student has guardians residing at more than one address.</p><p>The request sheets will be automatically downloaded to your computer in the printable PDF format when you click the \"Submit\" button.</p>";
    }

// GRADES
if(User('PROFILE')=='admin')
{
	$help['Grades/ReportCards.php'] = "<p><strong>Report Cards</strong></p><p><i></i>This utility allows you to print report cards for any number of students.</p><p>You can search for students who are enrolled in a specific course by clicking the \"Choose\" link next to the \"Course\" search option and choosing a course from the popup window that appears. You can also limit your search based on weighted/unweighted GPA, class rank, and letter grade by filling in the upper and lower bounds of the GPA and class rank range and checking the desired letter grade checkboxes.  For example, this allows you to search for all students in the top ten of their class, all students who are failing, or all students who have failed at least one course in the marking periods selected.</p><p>Also, you can choose to print the report cards with mailing labels.  The report cards will have mailing labels positioned in such a way as to be visible in a windowed envelope when the sheet is folded in thirds.  More than one report card may be printed per student if the student has guardians residing at more than one address.</p><p>Before printing the report cards, you must select which marking periods to display on the report card by checking desired marking period checkboxes.</p><p>The report cards will be automatically downloaded to your computer in the printable PDF format when you click the \"Submit\" button.</p>";
	$help['Grades/CalcGPA.php'] = "<p><strong>Calculate GPA</strong></p><p>This utility calculates and saves the GPA and class rank of each student in your school based upon their semester grades.</p><p>You must confirm your intention to calculate GPA. Here, you can also specify what number your weighted scale is based upon and whether to base class rank upon weighted or unweighted GPA.</p><p>The Calculate GPA program calculates the weighted GPA earned per course by multiplying the GPA value of the grade earned by the GPA multiplier of the course weight.  Then, it divides that value by the number you specified as the base for your weighted scale.  For unweighted GPA, the Calculate GPA program simply takes the GPA value of the grade the student earned.  After finding the GPA points earned for each course, the program averages these values to determine the student's to-date GPA.  It then sorts these values to determine the class rank.  If more than one student has the same GPA, they will share a position in class rank.</p>";
	$help['Grades/Transcripts.php'] = "<p><strong>Transcripts</strong></p><p>This utility allows you to print transcripts for any number of students.</p><p>You can search for students who are enrolled in a specific course by clicking the \"Choose\" link next to the \"Course\" search option and choosing a course from the popup window that appears. You can also limit your search based on weighted/unweighted GPA, class rank, and letter grade by filling in the upper and lower bounds of the GPA and class rank range and checking the desired letter grade checkboxes.  For example, this allows you to search for all students in the top ten of their class, all students who are failing, or all students who have failed at least one course in the marking periods selected.</p><p>Before printing the transcripts, you must select which marking periods to display on the transcript by checking desired marking period checkboxes.</p><p>The transcripts will be automatically downloaded to your computer in the printable PDF format when you click the \"Submit\" button.</p>";
	$help['Grades/TeacherCompletion.php'] = "<p><strong>Teacher Completion Report</strong></p><p>This report shows which teachers have not entered grades for any given marking period.</p><p>The red checks indicate that a teacher has failed to enter the current marking period's grades for that period.</p><p>You can select the current quarter, semester, and semester exam from the pull-down menu at the top of the screen.  To change the current quarter, change the marking period pull-down menu on the left frame.  You can also show only one period by choosing that period from the period pull-down menu at the top of the screen.  After choosing a marking period or period, click the \"Go\" button to refresh the list with the new parameters.</p>";
	$help['Grades/GradeBreakdown.php'] = "<p><strong>Grade Breakdown</strong></p><p>This report shows the number of each grade that a teacher gave.</p><p>You can select the current quarter, semester, and semester exam from the pull-down menu at the top of the screen.  To change the current quarter, change the marking period pull-down menu on the left frame.</p>";
	$help['Grades/ReportCards.php?modfunc=gradelist'] = "<p><strong>Student Grades Report</strong></p><p>This report allows you to view the grades earned by any number of students.</p><p>You can search for students who are enrolled in a specific course by clicking the \"Choose\" link next to the \"Course\" search option and choosing a course from the popup window that appears. You can also limit your search based on weighted/unweighted GPA, class rank, and letter grade by filling in the upper and lower bounds of the GPA and class rank range and checking the desired letter grade checkboxes.  For example, this allows you to search for all students in the top ten of their class, all students who are failing, or all students who have failed at least one course in the marking periods selected.</p><p>Before searching, you must select which marking periods to display by checking desired marking period checkboxes.</p>";
	$help['Grades/GPARankList.php'] = "<p><strong>GPA / Class Rank List</strong></p><p>This report that shows the unweighted GPA, weighted GPA, and class rank of each student at your school.</p><p>As with any list in openSIS, you can sort by any value displayed by clicking on the coresponding column heading.  For example, you can sort by grade by clicking on the \"Grade\" column heading.  Similarly, you can sort by unweighted GPA by clicking on the \"Unweighted GPA\" column heading.</p>";
	$help['Grades/ReportCardCodes.php'] = '<p><strong>Report Card Codes</strong></p><p>This page allows you to setup your school\'s report card codes.  Report card codes are used in the Input Final Grades program by teachers and in most of the Grades reports. Report card codes include letter grades as well as grade comments that a teacher can choose from when entering grades.</p><p>To add a report card grade, fill in the grade\'s title, GPA value, and sort order in the empty fields at the bottom of the grades list and click the "Save" button.</p><p>To add a comment, enter the new comment\'s title in the empty field at the bottom of the comments list.</p><p>To modify either type of code, click on any of the code\'s information, change the value, and click the "Save" button.</p><p>To delete either type of code, click the delete icon (-) next to the code you want to delete.  You will be asked to confirm the deletion.</p>';

}
elseif(User('PROFILE')=='parent')
{
	$help['Grades/ReportCards.php'] = "<p><strong>Report Cards</strong></p><p>This utility allows you to print report cards for your child.</p><p>Before printing the report cards, you must select which marking periods to display on the report card by checking desired marking period checkboxes.</p><p>The report cards will be automatically generated in a printer-friendly html page when you click the \"Submit\" button.</p>";
	$help['Grades/Transcripts.php'] = "<p><strong>Transcripts</strong></p><p>This utility allows you to print transcripts for your child.</p><p>Before printing the transcripts, you must select which marking periods to display on the transcript by checking desired marking period checkboxes.</p><p>The transcripts will be automatically generated in a printer-friendly html page when you click the \"Submit\" button.</p>";
	$help['Grades/ReportCards.php?modfunc=gradelist'] = "<p><strong>Student Grades</strong></p><p>This page allows you to view the grades earned by your child.</p><p>Before searching, you must select which marking periods to display by checking desired marking period checkboxes.</p>";
	$help['Grades/GPARankList.php'] = "<p><strong>GPA / Class Rank List</strong></p><p>This report that shows the unweighted GPA, weighted GPA, and class rank of your child.</p>";
$help['Grades/InputFinalGrades.php'] = "<p><strong>Input Final Grades</strong></p><p>This page allows you to enter quarter, semester, and semester exam grades for all your students in the current period.  By default, this program will list the students in your first period class for the current quarter.  You can alter the quarter by changing the marking period pull-down menu on the left frame.  Also, you can select the current semester or semester final by changing the marking period pull-down menu at the top of the screen to the desired marking period.</p><p>Once you are in the correct marking period, you can enter student grades by selecting the earned grade for each student and entering comments as desired.  Once all the grades and comments have been entered, click the \"Save\" button at the top of the screen.</p><p>If you are using the Gradebook, you can have openSIS calculate each student's quarter grades by clicking on the \"Use Gradebook Grades\" link at the top of the list.  Clicking this link will automatically save each student's grades and refresh the list.</p>";
	$help['Grades/Configuration.php'] = "<p><strong>Configuration</strong></p><p>This page allows you to configure the gradebook.</p><p>You can configure the gradebook to round scores up, down, or normally.  Normal rounding would round 19.5 to 20 but 19.4 to 19.</p><p>You can also configure the score breakoff points for each letter grade.  For example, if you set the score breakoff points for A+, A, and A- to 99, 91, and 90 respectively, a student with 99% to 100% would have an A+, another student with a 91% to 98% would have an A, and a student with a 90% would have an A-. The score breakoff point for F should probably be 0.</p><p>Finally, you can also configure the final grading percentages of each semester.  These values are used when averaging the quarter and semester exam grades to calculate the semester grade.</p>";
	$help['Grades/Assignments.php'] = '<p><strong>Assignments</strong></p><p>This page allows you to setup your assignments.  There are two tiers involved with assignments: assignment types and assignments.</p><p>You will probably have assignment types called "Homework," "Tests," and perhaps "Quizzes."  Assignment types are set for every period on which you teach any given course.  So, if you teach Algebra on 1st and 3rd period, you will have to add assignment types to only one of these periods.</p><p>To add an assignment type or an assignment, click on the Add icon (+) in the column corresponding to what you want to add.  Then, fill in the information in the fields above the list of assignments / types and click the "Save" button.</p><p>If you check "Apply to all Periods for this Course," the assignment will be added for each period for which you teach a specific course, in the same way assignment types are added.</p><p>To change an assignment or type, click on the assignment or type you want to modify and click on the value you want to change in the grey area above the assignments / types lists.  Then, change the value and click the "Save" button.</p><p>Finally, to delete an item, select it by clicking on its title on the list and click the "Delete" button at the top of the screen.  You will be asked to confirm the deletion.</p>';
	$help['Grades/Grades.php'] = "<p><strong>Grades</strong></p><p>This page allows you to input assignment grades for all your students in the current period. By default, this program will list the students in your first period class.  You can alter the current period by changing the period pull-down menu in the left frame to the desired period.</p><p>Once you have chosen the correct period, you will see the total points and cumulative grade for each student in your class. You can view the grades for an assignment by selecting the assignment from the assignment pull-down menu at the top of the screen. From here, you can input a new grade by entering the points earned into the blank field next to the student's name or you can modify an existing grade by clicking on the points earned and changing the value. After changing the grades, click the \"Save\" button at the top of the screen.</p><p>You can also view and change all the grades for a single student by clicking on the student's name in the list.  Input grades in the same way that you did with the multiple student list.</p>";
	$help['Grades/ProgressReports.php'] = "<p><strong>Progress Reports</strong></p><p>This report that allows you to print progress reports for any number of students.</p><p>You can choose to print the progress reports with mailing labels.  The progress reports will have mailing labels positioned in such a way as to be visible in a windowed envelope when the sheet is folded in thirds.  More than one progress report may be printed per student if the student has guardians residing at more than one address.</p><p>The progress reports will be automatically downloaded to your computer in the printable PDF format when you click the \"Submit\" button.</p>";

}

if(User('PROFILE')=='teacher')
{
    $help['Grades/ReportCards.php'] = "<p><strong>Report Cards</strong></p><p><i></i>This utility allows you to print report cards for any number of students.</p><p>You can search for students who are enrolled in a specific course by clicking the \"Choose\" link next to the \"Course\" search option and choosing a course from the popup window that appears. You can also limit your search based on weighted/unweighted GPA, class rank, and letter grade by filling in the upper and lower bounds of the GPA and class rank range and checking the desired letter grade checkboxes.  For example, this allows you to search for all students in the top ten of their class, all students who are failing, or all students who have failed at least one course in the marking periods selected.</p><p>Also, you can choose to print the report cards with mailing labels.  The report cards will have mailing labels positioned in such a way as to be visible in a windowed envelope when the sheet is folded in thirds.  More than one report card may be printed per student if the student has guardians residing at more than one address.</p><p>Before printing the report cards, you must select which marking periods to display on the report card by checking desired marking period checkboxes.</p><p>The report cards will be automatically downloaded to your computer in the printable PDF format when you click the \"Submit\" button.</p>";


}

// ATTENDANCE
if(User('PROFILE')=='admin')
{
	$help['Attendance/Administration.php'] = "<p><strong>Administration</strong></p><p>This page allows you to view and change the student attendance records for any given day.</p><p>To change the student's attendance status for any period, click on the current value and select the short name of the attendance code you would like to assign that student.  After making all the desired modifications, click the \"Update\" button at the top of the screen.  You can also limit the list of students based upon what attendance codes the students have been assigned on the current day.  For instance, by default, all students with any attendance codes with a state value of \"Absent\" are listed.  This is shown by the pull-down menu on the upper right-hand corner of the screen that displays \"Abs.\" This menu can be changed to the short name of any attendance code, and only students who received that code during the current day will be displayed.  This menu can even be changed to \"All\" which will list all students for whom attendance has been taken.  You can add an attendance code by clicking the add icon (+) next to the attendance code pull-down menu.  If you select a second attendance code, the program will list students who received either code during the day.</p><p>You can alter the date displayed by clicking on the date on the upper left-hand side of the screen and changing it to the desired date.</p><p>After making changes to the attendance codes displayed or the current date, click the \"Update\" button to refresh the screen with the new parameters.</p><p>You can also view the attendance code assigned to the student by the teacher as well as view and enter a comment for each period by clicking on the student's name.</p><p>Clicking on \"Current Student\" on the top of the screen will display the day's attendance records for the current student displayed in the left frame.</p>";
	$help['Attendance/AddAbsences.php'] = "<p><strong>Add Absences</strong></p><p>This page allows you to add an absence to a group of students in one action.</p>First, search for students.  Notice that you can search for students who are enrolled in a specific course or are in a certain activity.  This can be useful since you can add an absence record for each period to all of Mrs. Smith's first period students or the football team who will be on an all day field trip.</p><p>From the search result, you can select any number of students. You can select all the students in the list by checking the checkbox in the blue column headings above the list. You can also specify the periods to mark the selected students, the absence code, the absence reason, and the date in the yellow box above the student list.  After you have selected each desired student from this list, all the desired periods, the absence code, absence reason, and absence date, click the \"Save\" button at the top of the screen.</p>";
	$help['Attendance/Percent.php'] = "<p><strong>Average Daily Attendance Report</strong></p><p>This report shows the number of students, days possible, the number of student days present, the number of student days absent, the Average Daily Attendance, the average number of students in attendance per day, and the average number of students absent per day for any date range at your school.  These numbers are broken down by grade.</p><p>You can alter the date range displayed by changing the date pull-down menus at the top of the screen and clicking the \"Go\" button.  You can also limit the numbers by searching by gender or any of the customizable data fields by clicking on the \"Advanced\" link.</p>";
	$help['Attendance/Percent.php?list_by_day=true'] = "<p><i>Average Daily Attendance by Day</i> is a report that shows the number of students, days possible, the number of student days present, the number of student days absent, and the Average Daily Attendance per day for any date range at your school.  These numbers are broken down by grade.</p><p>You can alter the date range displayed by changing the date pull-down menus at the top of the screen and clicking the \"Go\" button.  You can also limit the numbers by searching by gender or any of the customizable data fields by clicking on the \"Advanced\" link.</p>";
	$help['Attendance/DailySummary.php'] = "<p><strong>Daily Summary Report</strong></p><p>This report shows the daily attendance status of any number of students for every date during any timeframe.</p><p>After searching for students, you can alter the date range by changing the date pull-down menus at the top of the screen and clicking the \"Go\" button.  The list shows each student's daily attendance value for each day with color codes.  A red box signifies that the student was absent all day, a yellow box signifies that a student was absent half-day, and a green box signifies that a student was present all day long.</p><p>You can see the attendance records for each period for any student by clicking on a student's name from the list.  Here, the absence code is displayed in the color-coded box.</p>";
	$help['Attendance/StudentSummary.php'] = "<p><strong>Student Summary</strong></p><p>This report shows the days for which a student has an absence.</p><p>After selecting a student, you can alter the date range by changing the date pull-down menus at the top of the screen and clicking the \"Go\" button.  The list shows the student's absences for each period of each day that he had an absence.  A red \"x\" indicates the student was absent in the corresponding period.</p>";
	$help['Attendance/TeacherCompletion.php'] = "<p><strong>Teacher Completion</strong></p><p>This report shows which teachers have not entered attendance for any given day.</p><p>The red checks indicate that a teacher has failed to enter the current day's attendance for that period.</p><p>You can select the current date from the pull-down menu at the top of the screen. You can also show only one period by choosing that period from the period pull-down menu at the top of the screen.  After choosing a date or period, click the \"Go\" button to refresh the list with the new parameters.</p>";
	$help['Attendance/AttendanceCodes.php'] = '<p><strong>Attendance Codes</strong></p><p>This page allows you to setup your school\'s attendance codes.  Attendance codes are used in the teacher\'s "Take Attendance" program (as well as most of the Attendance reports) and specify whether or not the student was present during the period, and if he wasn\'t, the reason.</p><p>To add an attendance code, fill in the attendance code\'s title, short name, type, and state code. Select whether or not the code should be a teacher\'s default from the empty fields at the bottom of the attendance codes list and click the "Save" button.  Generally, the attendance code called "Present" will be marked as the teacher\'s default.  If the attendance code is marked as being type "Teacher," a teacher will be able to select that attendance code from their "Take Attendance" program. Administrators will be able to assign all codes to a student.</p><p>To modify an attendance code, click on any of the attendance code\'s information, change the value, and click the "Save" button.</p><p>To delete an attendance code, click the delete icon (-) next to the attendance code you want to delete.  You will be asked to confirm the deletion.</p>';

}
elseif(User('PROFILE')=='parent')
	$help['Attendance/DailySummary.php'] = "<p><strong>Daily Summary</strong></p><p> is a report that shows the daily attendance status of your child during any timeframe.</p><p>You can alter the date range by changing the date pull-down menus at the top of the screen and clicking the \"Go\" button.  The list shows your child's daily attendance value for each period of each day with color codes.  A red box signifies that the student was absent that period, and a green box indicates that the student was either present or tardy that period. The absence code is displayed in the box.</p>";
if(User('PROFILE')=='teacher')
	{$help['Attendance/TakeAttendance.php'] = "<p><strong>Take Attendance</strong></p><p> allows you to enter period attendance for all your students in the current period.  By default, this program will list the students in your first period class.  You can alter the current period by changing the period pull-down menu in the left frame to the desired period.</p><p>Once you are in the correct period, you can enter attendance by selecting the attendance code corresponding to each student.  Once you have entered attendance for all your students, click the \"Save\" button at the top of the screen.</p>";
      $help['Attendance/DailySummary.php'] = "<p><strong>Daily Summary Report</strong></p><p>This report shows the daily attendance status of any number of students for every date during any timeframe.</p><p>After searching for students, you can alter the date range by changing the date pull-down menus at the top of the screen and clicking the \"Go\" button.  The list shows each student's daily attendance value for each day with color codes.  A red box signifies that the student was absent all day, a yellow box signifies that a student was absent half-day, and a green box signifies that a student was present all day long.</p><p>You can see the attendance records for each period for any student by clicking on a student's name from the list.  Here, the absence code is displayed in the color-coded box.</p>";
      $help['Attendance/StudentSummary.php'] = "<p><strong>Student Summary</strong></p><p>This report shows the days for which a student has an absence.</p><p>After selecting a student, you can alter the date range by changing the date pull-down menus at the top of the screen and clicking the \"Go\" button.  The list shows the student's absences for each period of each day that he had an absence.  A red \"x\" indicates the student was absent in the corresponding period.</p>";
 }
// ELIGIBILITY
if(User('PROFILE')=='admin')
{
	$help['Eligibility/Student.php'] = "<p><strong>Student Screen</strong></p><p>This page displays the student's activities and the current timeframe's eligibility grades. The program also allows you to add and delete activities to the student.<p>You must first select a student by using the \"Find a Student\" search screen. You can search for students who are enrolled in a specific course by clicking on the \"Choose\" link next to the \"Course\" search option and choosing a course from the popup window that appears. You can also search for students in a certain activity and for students who are currently ineligible.</p><p>To add an activity to the student, select the desired activity from the activity pull-down next to the add icon (+) and click the \"Add\" button.</p><p>To drop an activity, click on the delete icon (-) next to the activity you want to drop.</p><p>You can specify the desired eligibility timeframe by choosing the desired timeframe from the pull-down menu at the top of the screen.  These timeframes are setup in the \"Entry Times\" program.</p>";
	$help['Eligibility/AddActivity.php'] = "<p><strong>Add Activity</strong></p><p>This page allows you to add an activity to a group of students in one action.</p><p>First, select an activity to be added from the pull-down menu at the top of the screen. You can also perform this action from the next screen.  Next, search for students.  Notice that you can search for students who are in a certain activity or course.  From the search result, you can select any number of students.  You can select all the students in the list by checking the checkbox in the blue column headings above the list. After you have selected each desired student from this list, click the \"Add Activity to Selected Students\" button at the top of the screen. If you have not yet chosen an activity, you must do that before you click this button.</p>";
	$help['Eligibility/Activities.php'] = '<p><strong>Activities</strong></p><p>This page allows you to setup your school\'s activities.</p><p>To add an activity, fill in the activity\'s title, beginning date, and ending date in the empty fields at the bottom of the activities list and click the "Save" button.</p><p>To modify an activity, click on any of the activity\'s information, change the value, and click the "Save" button.</p><p>To delete an activity, click the delete icon (-) next to the activity you want to delete.  You will be asked to confirm the deletion.</p>';
	$help['Eligibility/EntryTimes.php'] = '<p><strong>Entry Times</strong></p><p>This page allows you to setup the weekly timeframe in which teachers can enter eligibility.  Teachers must enter eligibility every week within this range.  Besides the teacher\'s "Enter Eligibility" program, this timeframe is used in most eligibility reports</p><p>To change the timeframe, simply change the upper and lower bounds of the timeframe and click the "Save" button.</p>';
	$help['Eligibility/StudentList.php'] = "<p><strong>Student List</strong></p><p>This report shows every course and eligibility grade assigned to any number of students.</p><p>After searching for students, you can specify the eligibility timeframe you want to view.  These timeframes are setup in the \"Entry Times\" program.</p>";
	$help['Eligibility/TeacherCompletion.php'] = "<p><strong>Teacher Completion Report</strong></p><p>This report shows which teachers have not entered eligibility for any given date range.  The date range is set in the \"Entry Times\" program.</p><p>The red checks indicate that a teacher has failed to enter the current date range's eligibility for that period.</p><p>You can select the current date range from the pull-down menu at the top of the screen. You can also show only one period by choosing that period from the period pull-down menu at the top of the screen.  After choosing a date range or period, click the \"Go\" button to refresh the list with the new parameters.</p>";
}
elseif(User('PROFILE')=='parent')
{
	$help['Eligibility/Student.php'] = "<p><strong>Student Screen</strong></p><p> is a display of your child's activities and the current timeframe's eligibility grades.<p>You can specify the eligibility timeframe you want to view by choosing the desired timeframe from the pull-down menu at the top of the screen.  Eligibility is entered once per week.</p>";
	$help['Eligibility/StudentList.php'] = "<p><strong>Student List</strong></p><p> is a report that shows every course and eligibility grade assigned to your child.</p><p>You can specify the eligibility timeframe you want to view by choosing the timeframe from the pull-down menu at the top of the screen and clicking the \"Go\" button.  Eligibility is entered once per week.</p>";
}
if(User('PROFILE')=='teacher')
	$help['Eligibility/EnterEligibility.php'] = "<p><strong>Enter Eligibility</strong></p><p> allows you to enter eligibility grades for all your students in the current period.  By default, this program will list the students in your first period class.  You can alter the current period by changing the period pull-down menu in the left frame to the desired period.</p><p>Once you are in the correct period, you can enter eligibility grades by selecting the eligibility code corresponding to each student.  Once you have entered eligibility for all your students, click the \"Save\" button at the top of the screen.</p><p>If you are using the Gradebook, you can have openSIS calculate each student's eligibility grades by clicking on the \"Use Gradebook Grades\" link at the top of the list.  Clicking this link will automatically save each student's eligibility grades and refresh the list.</p><p>You must enter eligibility each week during the timeframe specified by your school's administration.</p>";

if(strpos($_SERVER['PHP_SELF'],'Help.php'))
{
	switch(User('PROFILE'))
	{
		case 'admin':
			$title = 'Administrator';
		break;

		case 'teacher':
			$title = 'Teacher';
		break;

		case 'parent':
			if($student==true)
				$title = 'Student';
			else
				$title = 'Parent';
		break;
	}

	$handle = PDFStart();
	Warehouse('header');
	echo '<TABLE><TR><TD><IMG SRC=assets/logo.gif></TD><TD><h1>'.$title.' Handbook<BR><small>Version 1.5</small></h1></TD></TR></TABLE><div class=break></div><!-- NEW PAGE -->';

	foreach($help as $program=>$value)
	{
		if(strpos($program,'/'))
		{
			$modcat = str_replace('_',' ',substr($program,0,strpos($program,'/')));
			if($modcat!=$old_modcat)
				echo '<!-- NEW PAGE --><TABLE border=0><TR><TD><IMG SRC=assets/icons/'.str_replace(' ','_',$modcat).'.gif></TD><TD><h1><font color=#333366>'.$modcat.'</font></h1></TD></TR></TABLE><div class=break></div>';
			$old_modcat = $modcat;
		}
		echo '<h2><font color=#333366>';
		$_REQUEST['modname'] = $program;
		if($program=='default')
			echo 'openSIS School Information System '.$title.' Handbook<BR><small>Version 1.5</small>';
		else
			echo ProgramTitle();
		echo '</font></h2>';
		echo '<TABLE border=0  bgcolor=#DDDDDD width=100%><TR><TD>';
		if($student==true)
			$value = str_replace('your child','yourself',str_replace('your child\'s','your',$value));
		echo $value;
		echo '</TD></TR></TABLE><BR>';
	}
	Warehouse('footer_plain');
	PDFStop($handle);
}
?>